import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

/** `bg̓eeLXg\NX
 */
public class CText extends Frame implements ActionListener{

	private Choice choice;
	private TextField field;
	private Button button;
	private TextArea area;
	private TextArea dummy;
	private PropertyFile property;
	private String name;
	private String color;
	private String reftime;
	private String email;
	private String userid;
	private String proxyHost;
	private String proxyPort;
	private String home;
	private String window;
	private Hashtable members;
	private javax.swing.Timer timer;
	private GetHtml gethtml;
	private boolean read = false;
	private boolean enter = false;

	private static final int ROM    = 1;
	private static final int CHAT   = 2;
	private static final int ENTER  = 3;
	private static final int EXIT   = 4;
	private static final int RELOAD = 5;

	/** RXgN^
	 */
	public CText(){
		Toolkit tk = Toolkit.getDefaultToolkit();
		setBounds(0,tk.getScreenSize().height-200,400,200);
		setVisible(true);
		setTitle("C-Text");
		setLayout(new BorderLayout());
		try{
			setIconImage(tk.createImage(this.getClass().getResource("icon.gif")));	//java2
		}catch(Exception e){
			e.printStackTrace();
		}

		//tHg̐ݒ

		Font font;
		font = new Font("monospaced",Font.PLAIN,12);

		//R|[lg̍쐬

		area = new TextArea("",40,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
		dummy = new TextArea("Test",40,10,TextArea.SCROLLBARS_VERTICAL_ONLY);
		add(area,"Center");

		Panel panel = new Panel(new BorderLayout());
		add(panel,"North");

		choice = new Choice();
		panel.add(choice,"West");

		field = new TextField();
		panel.add(field,"Center");

		button = new Button("");
		Button conf = new Button("ݒ");

		Panel buttons = new Panel(new GridLayout(1,2,0,0));
		buttons.add(button);
		buttons.add(conf);

		panel.add(buttons,"East");

		//R|[lg̔zu

		choice.add("Chat");
		//area.setEditable(false);//݋֎~

		area.setFont(font);
		field.setFont(font);
		choice.setFont(font);
		button.setFont(font);

		//tH[JẌړ
		field.requestFocus();

		//t[̐ݒ
		setVisible(true);

		field.addActionListener(this);
		button.addActionListener(this);
		conf.addActionListener(this);
		addWindowListener(
			new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					System.exit(0);
				}
			}
		);

		//ݒ
		property = PropertyFile.getInstance(System.getProperty("user.dir")+System.getProperty("file.separator")+"CText.properties");
		setProperty(property);

		window = "10";
		members = new Hashtable();
		if(reftime != null) timer = new javax.swing.Timer(Integer.valueOf(reftime).intValue()*1000,this);
		//timer = new Timer(5000,this);	//eXgp
		//timer.start();				//eXgp
	}

	/** ݒ
	 *  @param property PropertyFilẽCX^X
	 */
	protected void setProperty(PropertyFile property){
		name = property.getProperty("name");
		color = property.getProperty("color");
		reftime = property.getProperty("reftime");
		email = property.getProperty("email");
		proxyHost = property.getProperty("proxyHost");
		proxyPort = property.getProperty("proxyPort");
		home = property.getProperty("home");
		Properties sysProperties = System.getProperties();
		if(proxyHost != null) sysProperties.put("proxyHost",proxyHost);
		if(proxyPort != null) sysProperties.put("proxyPort",proxyPort);
		if(property.getProperty("proxySet") != null)  sysProperties.put("proxySet",property.getProperty("proxySet"));
	}

	/** Cxg̏
	 *  @param e ActionEventIuWFNg
	 */
	public void actionPerformed(ActionEvent e){
		String command = e.getActionCommand();
		if(command == null) return;

		if(e.getSource() == timer){
			reload();
		}

		if(e.getSource() == gethtml){
			if(e.getID() == ROM){
				read = false;
				area.setText(simpleRomHtml(command));
			}else if(e.getID() == CHAT){
				read = false;
				area.setText(simpleChatHtml(command));
				field.selectAll();
			}else if(e.getID() == RELOAD){
				read = false;
				area.setText(simpleChatHtml(command));
			}else if(e.getID() == ENTER){
				enter = true;
				userid = getId(command);
				reload();
			}else if(e.getID() == EXIT){
				enter = false;
				userid = "";
				reload();
			}

			setStatus();
			area.setCaretPosition(0);
			field.requestFocus();
		}

		if(e.getSource() == field){
			if(command.equals("")){
				reload();
			}else if(command.startsWith("line:")){
				window = command.substring(5,command.length());
				reload();
			}else if(choice.getSelectedIndex() == 0){
				chat(command);
			}else{
				denpo((String)members.get(choice.getSelectedItem()),command);
			}
		}

		if(command.equals("")){
			read = true;
			setStatus();
			getHtml(home+"webchat.cgi","action=regist"+"&name="+name+"&color="+color+"&email="+email+"&profile="+field.getText(),ENTER);
			button.setLabel("ގ");
			timer.start();
		}

		if(command.equals("ގ")){
			read = true;
			setStatus();
			field.setText("");
			getHtml(home+"webchat.cgi?action=bye&key="+userid,null,EXIT);
			button.setLabel("");
			timer.stop();
		}

		if(command.equals("ݒ")){
			PropertyDialog config = new PropertyDialog(this,property);
			config.setVisible(true);
			setProperty(config.property);
			config = null;
		}
	}

	/** ēǂݍ݂̏B
	 */
	protected void reload(){
		read = true;
		setStatus();
		if(enter){
			getHtml(home+"webchat.cgi","action=chat"+"&key="+userid+"&name="+name+"&color="+color+"&email="+email+"&chat=&kao=none&window="+window,RELOAD);
		}else{
			getHtml(home+"webchat.cgi?action=rom&window="+window,null,ROM);
		}
	}

	/** ̏B
	 *  @param command 
	 */
	protected void chat(String command){
		read = true;
		setStatus();
		getHtml(home+"webchat.cgi","action=chat"+"&key="+userid+"&name="+name+"&color="+color+"&email="+email+"&chat="+command+"&kao=none",CHAT);
	}

	/** d̏
	 *  @param denpoTo dID
	 *  @param command 
	 */
	protected void denpo(String denpoTo,String command){
		read = true;
		setStatus();
		getHtml(home+"webchat.cgi","action=chat"+"&key="+userid+"&name="+name+"&color="+color+"&email="+email+"&target="+denpoTo+"&denpo="+command,CHAT);
	}

	/** ^Cgo[ɒʐMԂ̕\
	 */
	protected void setStatus(){
		String title = "C-Text";
		if(enter) title += " enter";
		if(read) title += " *";
		setTitle(title);
	}

	/** HTML̎擾
	 *  @param urlstring HTML擾URL
	 *  @param poststring POST
	 *  @param mode [hID
	 */
	protected void getHtml(String urlstring,String poststring,int mode){
		gethtml = new GetHtml(urlstring,poststring,mode,this);
		gethtml.start();
	}

	/** ID̎擾
	 *  @param html HTML
	 *  @return ID
	 */
	protected String getId(String html){
		String result = "";
		int index = 0;
		int tail;
		index = html.indexOf("<frame ",index);
		index = html.indexOf("key",index);
		index = html.indexOf("=",index);
		tail = html.indexOf("&",index+1);
		result = html.substring(index+1,tail);
		return(result);
	}

	/** HTML̃eLXg
	 *  @param html HTML
	 *  @return eLXgꂽHTML
	 */
	protected String simpleRomHtml(String html){
		String result = html;
		int head = html.indexOf("</form>");
		int tail = html.indexOf("<h3>",head+7);
		if(head != -1 && tail != -1){
			result = html.substring(head+7,tail);
		}

		return(simpleHtml(result));
	}

	/** HTML^O菜iCHATpj
	 *  @param html HTML
	 *  @return ^O菜ꂽHTML
	 */
	protected String simpleChatHtml(String html){
		int index,head,tail;
		index = html.indexOf("d")+6;
		index = html.indexOf("<option ",index)+8;
		members.clear();
		choice.removeAll();
		choice.add("Chat");

		for(int i=0;true;i++){
			index = html.indexOf("<option ",index);
			if(index == -1) break;
			index += 8;
			head = html.indexOf("\"",index)+1;
			tail = html.indexOf("\"",head);
			String value = html.substring(head,tail);
			head = html.indexOf(">",tail)+1;
			tail = html.indexOf("\n",head);
			String name = html.substring(head,tail);
			members.put(name,value);
			choice.add(name);
		}

		String result = html;
		head = html.indexOf("</form>");
		tail = html.indexOf("<br>",head+7);
		if(head != -1 && tail != -1){
			result = html.substring(head+7,tail);
		}

		return(simpleHtml(result));
	}

	/** HTML^O̒uB
	 *  @param html HTML
	 *  @return ^OuꂽHTML
	 */
	protected String simpleHtml(String html){
		String result = html;
		result = replace(result,"\n","");
		result = replace(result,"<hr>","\n");
		result = replace(result,"<img src=\"./mark1.gif\">","(^v^)");
		result = replace(result,"<img src=\"./mark2.gif\">","(-_-#");
		result = replace(result,"<img src=\"./mark3.gif\">","(-_-)");
		result = replace(result,"<img src=\"./mark4.gif\">","(-_-;");
		result = replace(result,"<img src=\"./mark5.gif\">","(?_?)");
		result = replace(result,"<img src=\"./mark6.gif\">","(^_^)");
		result = replace(result,"<img src=\"./mark7.gif\">","(T_T)");
		result = replace(result,"","");
		result = deleteTags(result);
		result = replace(result,"&lt;","<");
		result = replace(result,"&gt;",">");
		return(result);
	}

	/** HTML^O菜iROMpj
	 *  @param html HTML
	 *  @return ^O菜ꂽHTML
	 */
	protected String deleteTags(String html){
		String result = "";
		int index = 0;
		int head,tail;
		while(index < html.length()){
			head = html.indexOf("<",index);
			if(head == -1) break;
			tail = html.indexOf(">",head);
			if(tail == -1) break;
			result += html.substring(index,head);
			index = tail+1;
		}
		return(result);
	}

	/** ̒uB
	 *  @param dest u{́B
	 *  @param str1 uO
	 *  @param str2 u㕶
	 *  @return uꂽ
	 */
	protected String replace(String dest,String str1,String str2){
		String result = "";
		int index = 0;
		int head,tail;
		while(index < dest.length()){
			head = dest.indexOf(str1,index);
			if(head == -1) break;
			tail = head+str1.length();
			if(tail == -1) break;
			result += dest.substring(index,head)+str2;
			index = tail;
		}
		if(index < dest.length()){
			result += dest.substring(index,dest.length());
		}
		return(result);
	}

	public static void main(String argv[]){
		new CText();
	}
}
