import java.lang.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

/** HTMLhLg擾NXB
 *  }`XbhHTMLhLg擾AANVCxg𔭍s܂B
 *  @author Y.Oyama
 */
public class GetHtml implements Runnable {
	private Thread thread;

	private String urlstring;
	private String poststring;
	private int id;
	private ActionListener listener;

	/** HTML擾NX̃CX^X𐶐܂B
	 *  @param urlstring HTML擾URLB
	 *  @param poststring POST镶B
	 *  @param id CxgʗpIDBĂяoŔCӂ̒lw肷B
	 *  @param listener Cxg̔s惊XiB
	 */
	public GetHtml(String urlstring,String poststring,int id,ActionListener listener){
		this.urlstring = urlstring;
		this.poststring = poststring;
		this.id = id;
		this.listener = listener;
	}

	/** HTML擾AANVCxg𔭍s܂B
	 */
	public void run(){
		listener.actionPerformed(new ActionEvent(this,id,get()));
	}

	/** HTML̎擾Jn܂B
	 */
	public void start(){
		thread = new Thread(this);
		thread.start();
	}

	/** HTML擾\bhB
	 *  @return 擾HTMLB
	 */
	protected String get(){
		String result = "";
		URLConnection connect = null;
		try{
			if(urlstring != null && urlstring != ""){
				URL url = new URL(urlstring);
				connect = url.openConnection();
				connect.setUseCaches(false);
				connect.setDoOutput(true);
			}

			if(poststring != null && poststring != "" && connect != null){
				PrintWriter out = new PrintWriter(connect.getOutputStream());
				out.print(poststring);
				out.close();
			}

			if(connect != null){
				BufferedReader in = new BufferedReader(new InputStreamReader(connect.getInputStream()));
				String outstr;
				while((outstr = in.readLine()) != null){
					result += outstr+"\n";
				}
				in.close();
			}
		}catch(Exception e){
			return(urlstring+" not found");
		}
		return(result);
	}
}
