import java.lang.*;
import java.util.*;
import java.io.*;

/** vpeBt@CǗNXB
 *  vpeBt@C̓o͂Sɍs܂B
 *  @author Y.Oyama
 */
public class PropertyFile{
	private static PropertyFile instance = null;
	private static Properties properties = new Properties();
	private static String filename = new String("default.properties");
	private static String header = new String("properties");

	/** vpeBt@CǗNX̍쐬B
	 */
	private PropertyFile(){
		loadProperty(new String());
	}
	
	/** CX^X擾B
	 *  @return PropertyFilẽCX^XB
	 */
	public static PropertyFile getInstance(){
		if(instance == null){
			instance = new PropertyFile();
		}
		return(instance);
	}

	/** CX^X擾it@CwjB
	 *  @param newfilename vpeBt@CB
	 *  @return PropertyFilẽCX^XB
	 */
	public static PropertyFile getInstance(String newfilename){
		if(instance == null){
			filename = newfilename;
			instance = new PropertyFile();
		}
		return(instance);
	}

	/** wb_̒lw肷B
	 *  @param header wb_B
	 */
	public void setHeader(String header){
		this.header = header;
	}

	/** vpeB̒l擾B
	 *  @param key vpeBB
	 *  @return vpeBlB
	 */
	public String getProperty(String key){
		return(properties.getProperty(key));
	}

	/** vpeB̒lۑB
	 *  @param key vpeBB
	 *  @param value vpeBlB
	 */
	public void setProperty(String key,String value){
		properties.setProperty(key,value);		//java2
	}

	/** vpeBt@C̃[hsB
	 *  @param newfilename vpeBt@CB
	 *  @return =trueAs=false
	 */
	public static synchronized boolean loadProperty(String newfilename){
		if (instance != null || properties.size() != 0){
			return(false);
		}
		
		if(newfilename == null || newfilename.length() == 0 ){
			newfilename = filename;
		}

		try{
			FileInputStream f = new FileInputStream(newfilename);
			properties.load(f);
			f.close();
		}catch(Exception e){
			System.out.println(e.toString());
			return(false);
		}
		return(true);
	}

	/** vpeBt@C̃Z[usB
	 *  @param newfilename vpeBt@CB
	 *  @return =trueAs=false
	 */
	public static synchronized boolean saveProperty(String newfilename){
		if (instance == null || properties.size() == 0){
			return(false);
		}
		
		if(newfilename == null || newfilename.length() == 0 ){
			newfilename = filename;
		}

		try{
			FileOutputStream f = new FileOutputStream(newfilename);
			properties.store(f,header);							//java2
			f.close();
		}catch(Exception e){
			System.out.println(e.toString());
			return(false);
		}
		return(true);
	}
}

